<div align="center">
  <h1 align="center">TTime</h3>
  <p align="center">Time Tracking Platform</p>
</div>

---

## Introduction

A time tracking platform that allows users to track their time and generate reports.

## Build Instructions

The full build instruction is available [here](./BUILD.md).  
For developers specializing in the **backend**, there is documentation [here](./backend/README.md).  
For developers specializing in the **frontend**, there is documentation [here](./frontend/README.md).  

Dependencies:

- [Go](https://go.dev/)
- [Make](https://www.gnu.org/software/make/)
- [Node & npm](https://nodejs.org/en/)
- [Podman](https://podman.io/) / [Docker](https://www.docker.com/)
- [Just](https://github.com/casey/just) (Optional)

If you're on [Fedora](https://fedoraproject.org/)/Red Hat derivatives, this is as simple as:

```bash
sudo dnf install -y make golang nodejs podman just
```

Any [Debian](https://www.debian.org/)/[Ubuntu](https://ubuntu.com/desktop)-based distro:

```bash
sudo apt install -y make golang nodejs podman
sudo apt install -y just # For Ubuntu
```

[Arch Linux](https://archlinux.org/) & derivatives:

```bash
sudo pacman -S make go nodejs npm podman just
```

[MacOS](https://www.apple.com/macos/): (Requires [Homebrew](https://brew.sh/)) (Untested)

```bash
brew install make go nodejs npm podman just
```

Further instructions will be provided for native Windows if there is demand for it.  
[Windows](https://www.microsoft.com/en-us/windows): (Requires [Windows Subsystem for Linux](https://docs.microsoft.com/en-us/windows/wsl/install)) (Untested)

```bash
sudo apt install -y make golang nodejs podman just
```
